function getById(id){
	return document.getElementById(id);
}

function calcular(){
	calcularPP();
	calcularWEB();
	calcularFinal();
}
	
function calcularPP(){

	var out_pp_objetivas = round(getById("pp_objetivas").value * 5);
	getById("out_pp_objetivas").innerHTML = out_pp_objetivas;
	
	var out_pp_11 = round(getById("pp_11").value);
	getById("out_pp_11").innerHTML = out_pp_11;
	
	var out_pp_12 = round(getById("pp_12").value);
	getById("out_pp_12").innerHTML = out_pp_12;
	
	var out_pp = round(out_pp_objetivas + out_pp_11 + out_pp_12);
	getById("out_pp").innerHTML = out_pp;
	
	if(out_pp<60 && out_pp>50){
		out_pp = 60;
	}
	getById("out_pp_conceito").innerHTML = converteConceito(out_pp);
	
}

function calcularWEB(){
	
	var out_web_ptg = round(getById("web_ptg").value);
	getById("out_web_ptg").innerHTML = out_web_ptg;
	
	var out_web_av1 = round(getById("web_av1").value);
	getById("out_web_av1").innerHTML = out_web_av1;
	
	var out_web_av2 = round(getById("web_av2").value);
	getById("out_web_av2").innerHTML = out_web_av2;
	
	var out_web_parcial = round(out_web_ptg + out_web_av1 + out_web_av2);
	getById("out_web_parcial_2").innerHTML = out_web_parcial;
	getById("out_web_parcial_conceito").innerHTML = converteConceito(out_web_parcial);
	getById("out_web_parcial").innerHTML = out_web_parcial;
	
	var out_web_parcial_80 =  round(out_web_parcial * 0.8);
	getById("out_web_parcial_80").innerHTML = out_web_parcial_80;
	
	var out_web_apresenta = round(getById("web_apresenta").value * 2);
	getById("out_web_apresenta").innerHTML = out_web_apresenta;
	
	var out_web = round(out_web_parcial_80 + out_web_apresenta);
	getById("out_web").innerHTML = out_web;
	
	getById("out_web_conceito").innerHTML = converteConceito(out_web);
	
}

function calcularFinal(){
	var out_final_pp = reverteConceito(getById("out_pp_conceito").innerHTML);
	getById("out_final_pp").innerHTML = out_final_pp;
	
	var out_final_pp_70 = out_final_pp * 0.7;
	getById("out_final_pp_70").innerHTML = out_final_pp_70;
	
	var out_final_web = reverteConceito(getById("out_web_conceito").innerHTML);
	getById("out_final_web").innerHTML = out_final_web;
	
	var out_final_web_30 = out_final_web * 0.3;
	getById("out_final_web_30").innerHTML = out_final_web_30;
	
	var out_final = out_final_pp_70 + out_final_web_30;
	if(out_final_pp==0 || out_final_web==0){
		out_final = 0;
	}
	getById("out_final").innerHTML = out_final;
	
	getById("out_final_conceito").innerHTML = converteConceito(out_final);
	
	$('#imgConceito').attr('src','img/conceito/'+converteConceitoImg(out_final)+'.png');
	
}

function round(valor){
	return Math.round(valor * 100) / 100;
}

var CONCEITO_IN = "Insuficiente";
var CONCEITO_SU = "Suficiente";
var CONCEITO_BO = "Bom";
var CONCEITO_MB = "Muito Bom";
var CONCEITO_EX = "Excelente";

function converteConceito(soma){
	if(soma<60){ return CONCEITO_IN; }
	else if(soma>=60 && soma<70){ return CONCEITO_SU; }
	else if(soma>=70 && soma<80){ return CONCEITO_BO; }
	else if(soma>=80 && soma<90){ return CONCEITO_MB; }
	else if(soma>=90){ return CONCEITO_EX; }
}

function converteConceitoImg(soma){
	if(soma<60){ return "in"; }
	else if(soma>=60 && soma<70){ return "su"; }
	else if(soma>=70 && soma<80){ return "bo"; }
	else if(soma>=80 && soma<90){ return "mb"; }
	else if(soma>=90){ return "ex"; }
}

function reverteConceito(conceito){
	if(conceito==CONCEITO_IN){ return 0; }
	else if(conceito==CONCEITO_SU){ return 69; }
	else if(conceito==CONCEITO_BO){ return 79; }
	else if(conceito==CONCEITO_MB){ return 89; }
	else if(conceito==CONCEITO_EX){ return 100; }
}

var HTML_OPCOES_CONCEITO = "<option value=\"0\">Insuficiente</option>"
	+ " <option value=\"69\">Suficiente</option> "
	+ " <option value=\"79\">Bom</option>"
	+ " <option value=\"89\">Muito Bom</option>"
	+ " <option value=\"100\">Excelente</option>";

var HTML_OPCOES_CONCEITO_P_P = "<option value=\"0\">Sem Conceito</option>"
	+ "<option value=\"7\">Insuficiente</option>"
	+ " <option value=\"17\">Suficiente</option> "
	+ " <option value=\"20\">Bom</option>"
	+ " <option value=\"23\">Muito Bom</option>"
	+ " <option value=\"25\">Excelente</option>";

var HTML_OPCOES_CONCEITO_P_T = "<option value=\"0\">Sem Conceito</option>"
	+ "<option value=\"0\">Insuficiente</option>"
	+ " <option value=\"44\">Suficiente</option> "
	+ " <option value=\"52\">Bom</option>"
	+ " <option value=\"58\">Muito Bom</option>"
	+ " <option value=\"66.66\">Excelente</option>";

var HTML_OPCOES_CONCEITO_A_V = "<option value=\"0\">Sem Conceito</option>"
	+ "<option value=\"0\">Insuficiente</option>"
	+ " <option value=\"11\">Suficiente</option> "
	+ " <option value=\"13\">Bom</option>"
	+ " <option value=\"14.5\">Muito Bom</option>"
	+ " <option value=\"16.67\">Excelente</option>";

var HTML_OPCOES_10 = "<option value=\"0\">0</option>"
	+ " <option value=\"1\">1</option>"
	+ " <option value=\"2\">2</option>"
	+ " <option value=\"3\">3</option>"
	+ " <option value=\"4\">4</option>"
	+ " <option value=\"5\">5</option>"
	+ " <option value=\"6\">6</option>"
	+ " <option value=\"7\">7</option>"
	+ " <option value=\"8\">8</option>"
	+ " <option value=\"9\">9</option>"
	+ " <option value=\"10\">10</option>";


var disciplinas = {
	index: -1,
	list: [ ],
	nameFile: '.disciplinas',
	update: function(){
		$("#ulDisciplinas").html('');
		for (var i in disciplinas.list) {
			var html = $('#templateLiDisciplina').html();
			html = templateReplace(html, "index", i);
			html = templateReplace(html, "nome", disciplinas.list[i].nome);
			html = templateReplace(html, "conceito", disciplinas.list[i].conceito);
			html = templateReplace(html, "conceito_img", disciplinas.list[i].conceito_img);
			$("#ulDisciplinas").append( html );
		}
		if(disciplinas.list.length>0){
			$("#ulDisciplinas").listview('refresh');
			$('#divZeroDisciplinas').hide();
		}else{
			$('#divZeroDisciplinas').show();
		}
	},
	show: function(index){
		disciplinas.index = index;
		$('.h1NomeDisciplina').html(disciplinas.list[disciplinas.index].nome);
		disciplinas.set();
		$.mobile.changePage('#pageDisciplina', { });
		$('#divNotas').children(':first').collapsible('expand');
	},
	showWithoutId: function(){
		if(disciplinas.index>=0){
			setTimeout( function(){ disciplinas.show(disciplinas.index); }, 100 );
		}
	},
	move: function(move){
		var temp = disciplinas.list[disciplinas.index];
		disciplinas.list.splice(disciplinas.index,1);
		disciplinas.index += move;
		disciplinas.list.splice(disciplinas.index, 0, temp);
		disciplinas.update();
		disciplinas.saveToFile();
	},
	moveUp: function(){
		if(disciplinas.index>0){
			disciplinas.move(-1);
		}
	},
	moveDown: function(){
		if(disciplinas.index<(disciplinas.list.length-1)){
			disciplinas.move(1);
		}
	},
	remove: function(){
		disciplinas.list.splice(disciplinas.index,1);
		disciplinas.update();
		disciplinas.saveToFile();
	},
	newForm: function(){
		$('#nomeNewDisciplina').val('');
		$('#btnNewDisciplina').hide();
		$('#divNewDisciplina').slideToggle();
		$('#nomeNewDisciplina').focus();
		if(disciplinas.list.length==0){
			$('#divZeroDisciplinas').hide();
		}
	},
	newOk: function(){
		if($('#nomeNewDisciplina').val()==''){
			utilidades.msgError('Escolha um nome');
		}else{
			var d = { nome: $('#nomeNewDisciplina').val(), conceito: 'Sem Conceito', conceito_img: 'sc' };
			disciplinas.list.push(d);
			disciplinas.update();
			disciplinas.saveToFile();
			disciplinas.newCancel();
		}
	},
	newCancel: function(){
		$('#divNewDisciplina').slideToggle();
		$('#btnNewDisciplina').show();
		if(disciplinas.list.length==0){
			$('#divZeroDisciplinas').show();
		}
	},
	set: function(){
		var d = disciplinas.list[disciplinas.index];
		
		changeSelectValue("pp_objetivas", (d.pp_objetivas? d.pp_objetivas : '0') );
		changeSelectValue("pp_11", (d.pp_11? d.pp_11 : '0') );
		changeSelectValue("pp_12", (d.pp_12? d.pp_12 : '0') );
		changeSelectValue("web_ptg", (d.web_ptg? d.web_ptg : '0') );
		changeSelectValue("web_av1", (d.web_av1? d.web_av1 : '0') );
		changeSelectValue("web_av2", (d.web_av2? d.web_av2 : '0') );
		changeSelectValue("web_apresenta", (d.web_apresenta? d.web_apresenta : '0') );
		
		calcular();
	},
	get: function(){
		var d = disciplinas.list[disciplinas.index];
		
		d.pp_objetivas = $("#pp_objetivas").val();
		d.pp_11 = $("#pp_11").val();
		d.pp_12 = $("#pp_12").val();
		d.web_ptg = $("#web_ptg").val();
		d.web_av1 = $("#web_av1").val();
		d.web_av2 = $("#web_av2").val();
		d.web_apresenta = $("#web_apresenta").val();
		
		disciplinas.list[disciplinas.index] = d;
		
		d.conceito = $("#out_final_conceito").html();
		d.conceito_img = converteConceitoImg( reverteConceito( $("#out_final_conceito").html() ) );
	},
	changeUpdate: function(){
		disciplinas.get();
		disciplinas.update();
		disciplinas.saveToFile();
	},
	saveToFile: function(){
		var content = JSON.stringify(disciplinas.list);
		appendLog('<h4>saveToFile</h4>'+content);
		try{
			fileWriter.write(aplicativo.dir,disciplinas.nameFile,content,function(evt){},function(error){appendLog('<h4>ERROR 1</h4>'+error);});	
		}catch(e){
			appendLog('<h4>ERROR 2</h4>'+e.message);
		}
	},
	getFromFile: function(){
		fileReader.read(
				aplicativo.dir,
				disciplinas.nameFile, 
				function(text) {
					appendLog('<h4>getFromFile</h4>'+text); 
					appendLog('<h4>stringfy</h4>'+JSON.stringify(text));
					try{ disciplinas.list = JSON.parse(text); disciplinas.update(); }
					catch(e1){ 
						appendLog('<h4>ERROR 1</h4>'+e1.message);
						try{ disciplinas.list = JSON.parse(JSON.stringify(text)); disciplinas.update(); }
						catch(e2){
							disciplinas.list = [ ];
							appendLog('<h4>ERROR 2</h4>'+e2.message);
						} 
					} 
				}, 
				function(error) { disciplinas.list = [ ]; }
			);
	},
	compartilharConceito: function(){
		var text = "Disciplina: "+disciplinas.list[disciplinas.index].nome
			+"\nConceito: "+$('#out_final_conceito').html()
			+"\n\nAplicativo Conceito Unopar: "
			+"\n"+aplicativo.appLink;
		window.plugins.socialsharing.share(text);		
	}
};

function changeSelectValue(id,value){
	$('#'+id).val(value);
	try{
		$('#'+id).selectmenu('refresh');
	}catch(e){}
}